## ktap 0.4+git20150927

=== Makefile ===

#
# Define NO_LIBELF if you do not want libelf dependency (e.g. cross-builds)
# (this will also disable resolve resolving symbols in DSO functionality)
#
# Define FFI if you want to compile ktap with FFI support. By default This
# toggle is off.
#
# Define amalg to enable amalgamation build, This compiles the ktapvm as
# one huge C file and allows GCC to generate faster and shorter code. Alas,
# this requires lots of memory during the build.
# Recommend to use amalgmation build as default.
amalg = 1

# Do not instrument the tracer itself:
ifdef CONFIG_FUNCTION_TRACER
ORIG_CFLAGS := $(KBUILD_CFLAGS)
KBUILD_CFLAGS = $(subst -pg,,$(ORIG_CFLAGS))
endif

all: mod ktap

INC = include
RUNTIME = runtime

FFIDIR = $(RUNTIME)/ffi
KTAP_LIBS = -lpthread

LIB_OBJS += $(RUNTIME)/lib_base.o $(RUNTIME)/lib_kdebug.o \
		$(RUNTIME)/lib_timer.o $(RUNTIME)/lib_ansi.o \
		$(RUNTIME)/lib_table.o $(RUNTIME)/lib_net.o

ifndef amalg
ifdef FFI
FFI_OBJS += $(FFIDIR)/ffi_call.o $(FFIDIR)/ffi_type.o $(FFIDIR)/ffi_symbol.o \
    $(FFIDIR)/cdata.o $(FFIDIR)/ffi_util.o
RUNTIME_OBJS += $(FFI_OBJS)
LIB_OBJS += $(RUNTIME)/lib_ffi.o
endif
RUNTIME_OBJS += $(RUNTIME)/ktap.o $(RUNTIME)/kp_bcread.o $(RUNTIME)/kp_obj.o \
		$(RUNTIME)/kp_str.o $(RUNTIME)/kp_mempool.o \
		$(RUNTIME)/kp_tab.o $(RUNTIME)/kp_vm.o \
		$(RUNTIME)/kp_transport.o $(RUNTIME)/kp_events.o $(LIB_OBJS)
else
RUNTIME_OBJS += $(RUNTIME)/amalg.o
endif

ifdef FFI
ifeq ($(KBUILD_MODULES), 1)
ifdef CONFIG_X86_64
# call_x86_64.o is compiled from call_x86_64.S
RUNTIME_OBJS += $(FFIDIR)/call_x86_64.o
else
$(error ktap FFI only supports x86_64 for now!)
endif
endif


ccflags-y	+= -DCONFIG_KTAP_FFI
endif

obj-m		+= ktapvm.o
ktapvm-y	:= $(RUNTIME_OBJS)

KVERSION ?= $(shell uname -r)
KERNEL_SRC ?= /lib/modules/$(KVERSION)/build
PWD := $(shell pwd)
mod:
	$(MAKE) -C $(KERNEL_SRC) M=$(PWD) modules

modules_install:
	$(MAKE) -C $(KERNEL_SRC) M=$(PWD) modules_install

KTAPC_CFLAGS = -Wall -O2 $(CPPFLAGS)


# try-cc
# Usage: option = $(call try-cc, source-to-build, cc-options, msg)
ifneq ($(V),1)
TRY_CC_OUTPUT= > /dev/null 2>&1
endif
TRY_CC_MSG=echo "    CHK $(3)" 1>&2;

try-cc = $(shell sh -c							\
         'TMP="/tmp/.$$$$";						\
          $(TRY_CC_MSG)							\
          echo "$(1)" |							\
          $(CC) -x c - $(2) -o "$$TMP" $(TRY_CC_OUTPUT) && echo y;	\
          rm -f "$$TMP"')


define SOURCE_LIBELF
#include <libelf.h>

int main(void)
{
        Elf *elf = elf_begin(0, ELF_C_READ, 0);
        return (long)elf;
}
endef

FLAGS_LIBELF = -lelf

ifdef NO_LIBELF
	KTAPC_CFLAGS += -DNO_LIBELF
else
ifneq ($(call try-cc,$(SOURCE_LIBELF),$(FLAGS_LIBELF),libelf),y)
    $(warning No libelf found, disables symbol resolving, please install elfutils-libelf-devel/libelf-dev);
    NO_LIBELF := 1
    KTAPC_CFLAGS += -DNO_LIBELF
else
    KTAP_LIBS += -lelf
endif
endif

UDIR = userspace

$(UDIR)/kp_main.o: $(UDIR)/kp_main.c $(INC)/* KTAP-CFLAGS
	$(QUIET_CC)$(CC) $(DEBUGINFO_FLAG) $(KTAPC_CFLAGS) -o $@ -c $<
$(UDIR)/kp_lex.o: $(UDIR)/kp_lex.c $(INC)/* KTAP-CFLAGS
	$(QUIET_CC)$(CC) $(DEBUGINFO_FLAG) $(KTAPC_CFLAGS) -o $@ -c $<
$(UDIR)/kp_parse.o: $(UDIR)/kp_parse.c $(INC)/* KTAP-CFLAGS
	$(QUIET_CC)$(CC) $(DEBUGINFO_FLAG) $(KTAPC_CFLAGS) -o $@ -c $<
$(UDIR)/kp_bcwrite.o: $(UDIR)/kp_bcwrite.c $(INC)/* KTAP-CFLAGS
	$(QUIET_CC)$(CC) $(DEBUGINFO_FLAG) $(KTAPC_CFLAGS) -o $@ -c $<
$(UDIR)/kp_reader.o: $(UDIR)/kp_reader.c $(INC)/* KTAP-CFLAGS
	$(QUIET_CC)$(CC) $(DEBUGINFO_FLAG) $(KTAPC_CFLAGS) -o $@ -c $<
$(UDIR)/kp_util.o: $(UDIR)/kp_util.c $(INC)/* KTAP-CFLAGS
	$(QUIET_CC)$(CC) $(DEBUGINFO_FLAG) $(KTAPC_CFLAGS) -o $@ -c $<
$(UDIR)/kp_parse_events.o: $(UDIR)/kp_parse_events.c $(INC)/* KTAP-CFLAGS
	$(QUIET_CC)$(CC) $(DEBUGINFO_FLAG) $(KTAPC_CFLAGS) -o $@ -c $<
ifndef NO_LIBELF
$(UDIR)/kp_symbol.o: $(UDIR)/kp_symbol.c KTAP-CFLAGS
	$(QUIET_CC)$(CC) $(DEBUGINFO_FLAG) $(KTAPC_CFLAGS) -o $@ -c $<
endif
ifdef FFI
KTAPC_CFLAGS += -DCONFIG_KTAP_FFI
$(UDIR)/ffi_type.o: $(RUNTIME)/ffi/ffi_type.c $(INC)/* KTAP-CFLAGS
	$(QUIET_CC)$(CC) $(DEBUGINFO_FLAG) $(KTAPC_CFLAGS) -o $@ -c $<
$(UDIR)/ffi/cparser.o: $(UDIR)/ffi/cparser.c $(INC)/* KTAP-CFLAGS
	$(QUIET_CC)$(CC) $(DEBUGINFO_FLAG) $(KTAPC_CFLAGS) -o $@ -c $<
$(UDIR)/ffi/ctype.o: $(UDIR)/ffi/ctype.c $(INC)/* KTAP-CFLAGS
	$(QUIET_CC)$(CC) $(DEBUGINFO_FLAG) $(KTAPC_CFLAGS) -o $@ -c $<
endif


KTAPOBJS =
KTAPOBJS += $(UDIR)/kp_main.o
KTAPOBJS += $(UDIR)/kp_lex.o
KTAPOBJS += $(UDIR)/kp_parse.o
KTAPOBJS += $(UDIR)/kp_bcwrite.o
KTAPOBJS += $(UDIR)/kp_reader.o
KTAPOBJS += $(UDIR)/kp_util.o
KTAPOBJS += $(UDIR)/kp_parse_events.o
ifndef NO_LIBELF
KTAPOBJS += $(UDIR)/kp_symbol.o
endif
ifdef FFI
KTAPOBJS += $(UDIR)/ffi_type.o
KTAPOBJS += $(UDIR)/ffi/cparser.o
KTAPOBJS += $(UDIR)/ffi/ctype.o
endif

ktap: $(KTAPOBJS) KTAP-CFLAGS
	$(QUIET_LINK)$(CC) $(LDFLAGS) $(KTAPC_CFLAGS) -o $@ $(KTAPOBJS) $(KTAP_LIBS)

KMISC := /lib/modules/$(KVERSION)/ktapvm/

install: mod ktap
	make modules_install ktapvm.ko INSTALL_MOD_PATH=$(DESTDIR)
	install -D -t $(DESTDIR)/usr/bin/ ktap

install_vim:
	mkdir -p ~/.vim/ftdetect
	mkdir -p ~/.vim/syntax
	cp vim/ftdetect/ktap.vim ~/.vim/ftdetect/
	cp vim/syntax/ktap.vim ~/.vim/syntax/

load:
	insmod ktapvm.ko

unload:
	rmmod ktapvm

reload:
	make unload; make load

test: FORCE
	#start testing
	prove -j4 -r test/

clean:
	$(MAKE) -C $(KERNEL_SRC) M=$(PWD) clean
	$(RM) ktap KTAP-CFLAGS


PHONY += FORCE
FORCE:

TRACK_FLAGS = KTAP
ifdef amalg
TRACK_FLAGS += AMALG
endif
ifdef FFI
TRACK_FLAGS += FFI
endif
ifdef NO_LIBELF
TRACK_FLAGS += NO_LIBELF
endif

KTAP-CFLAGS: FORCE
	@FLAGS='$(TRACK_FLAGS)'; \
	if test x"$$FLAGS" != x"`cat KTAP-CFLAGS 2>/dev/null`" ; then \
		echo "$$FLAGS" >KTAP-CFLAGS; \
	fi

#generate tags/etags/cscope index for editor.
define all_sources
        (find . -name '*.[ch]' -print)
endef

.PHONY: tags
tags:
	$(all_sources) | xargs ctags

.PHONY: etags
etags:
	$(all_sources) | xargs etags

.PHONY: cscope
cscope:
	$(all_sources) > cscope.files
	cscope -k -b

=== test/ffi_test/Makefile ===
obj-m += ktap_ffi_test.o

all: funct_mod cparser_test

funct_mod:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) modules

INC=../../include
U_DIR=../../userspace
RUNTIME=../../runtime
U_FFI_DIR=$(U_DIR)/ffi
CPARSER_FILES=cparser.o ctype.o ffi_type.o
KTAPC_CFLAGS = -Wall -O2

cparser.o: $(U_FFI_DIR)/cparser.c $(INC)/*
	$(QUIET_CC)$(CC) -DCONFIG_KTAP_FFI -o $@ -c $<

ctype.o: $(U_FFI_DIR)/ctype.c $(INC)/*
	$(QUIET_CC)$(CC) -DCONFIG_KTAP_FFI -o $@ -c $<

ffi_type.o: $(RUNTIME)/ffi/ffi_type.c $(INC)/*
	$(QUIET_CC)$(CC) -DCONFIG_KTAP_FFI -o $@ -c $<

cparser_test: cparser_test.c $(CPARSER_FILES) $(INC)/*
	$(QUIET_CC)$(CC) -DCONFIG_KTAP_FFI -I$(INC) -I$(U_DIR) $(KTAPC_CFLAGS) \
		-o $@ $< $(CPARSER_FILES)

load:
	insmod ktap_ffi_test.ko

unload:
	rmmod ktap_ffi_test

test: all
	@echo "testing cparser:"
	./cparser_test
	@echo "testing ffi module:"
	rmmod ktap_ffi_test > /dev/null 2>&1 || true
	insmod ktap_ffi_test.ko
	../../ktap ffi_test.kp
	rmmod ktap_ffi_test.ko
	@echo "[*] all ffi tests passed."

clean:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) clean
	rm -rf cparser_test

=== debian/changelog ===
ktap (0.4+git20150927-1) unstable; urgency=low

  * Initial release (Closes: #740061)

 -- Azat Khuzhin <a3at.mail@gmail.com>  Sun, 27 Sep 2015 20:25:48 +0300

=== debian/control ===
Source: ktap
Section: devel
Priority: optional
Maintainer: Azat Khuzhin <a3at.mail@gmail.com>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.14.6),
               dkms (>= 2.1.1.1),
               libelf-dev,
               pandoc,
               help2man
Standards-Version: 3.9.6
Homepage: http://www.ktap.org
Vcs-Git: git://anonscm.debian.org/collab-maint/ktap.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/ktap.git

Package: ktap
Architecture: any
Depends: libelf1, dkms (>= 2.1.1.1), ${shlibs:Depends}, ${misc:Depends}
Description: lightweight script-based dynamic tracing tool for Linux
 ktap is a new script-based dynamic tracing tool for Linux, it uses a scripting
 language and lets users trace the Linux kernel dynamically. ktap is designed to
 give operational insights with interoperability that allows users to tune,
 troubleshoot and extend kernel and application. It's similar with Linux
 Systemtap and Solaris Dtrace.
 .
 ktap have different design principles from Linux mainstream dynamic tracing
 language in that it's based on bytecode, so it doesn't depend upon GCC, doesn't
 require compiling kernel module for each script, safe to use in production
 environment, fulfilling the embedded ecosystem's tracing needs.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
VERSION = $(shell dpkg-parsechangelog --show-field Version)
DESCRIPTION = $(shell fgrep Description: debian/control | cut -d' ' -f2-)
include /usr/share/dpkg/default.mk

export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
#export DH_VERBOSE=1

# main packaging script based on dh7 syntax
%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- ktap
override_dh_auto_install:
	dh_install ktap /usr/bin/
	dh_dkms -V $(VERSION)
override_dh_auto_clean:
	dh_clean ktap KTAP-CFLAGS
override_dh_install:
	dh_install --exclude=debian Makefile runtime include usr/src/ktapvm-$(VERSION)/

# TODO(azat):
override_dh_auto_test:
#	make load
#	make test
#	make unload

override_dh_installman:
	help2man --no-info --include debian/ktapvm --no-discard-stderr -h-h --version-string $(VERSION) -n "$(DESCRIPTION)" ./ktap > debian/ktap.1
	dh_installman

override_dh_installdocs:
	mkdir -p debian/doc
	pandoc -o debian/doc/tutorial.html doc/tutorial.md
	dh_installdocs debian/doc/tutorial.html
	dh_installdocs samples

override_dh_installchangelogs:
	dh_installchangelogs RELEASES.txt

## ktap 0.4+git20160427

=== Makefile ===
--- 
+++ 
@@ -105,7 +105,7 @@
 	KTAPC_CFLAGS += -DNO_LIBELF
 else
 ifneq ($(call try-cc,$(SOURCE_LIBELF),$(FLAGS_LIBELF),libelf),y)
-    $(warning No libelf found, disables symbol resolving, please install elfutils-libelf-devel/libelf-dev);
+    $(warning No libelf found, disables symbol resolving, please install elfutils-libelf-devel);
     NO_LIBELF := 1
     KTAPC_CFLAGS += -DNO_LIBELF
 else

=== debian/changelog ===
ktap (0.4+git20160427-1ubuntu4) bionic; urgency=medium

  * Linux 5.2 and 5.3 compatibility (LP: #1849569)
    - debian/patches/fix-stacktrace-5.2.patch
    - debian/patches/fix-tracing_generic_entry_update-5.3.patch

 -- Marcelo Henrique Cerri <marcelo.cerri@canonical.com>  Fri, 15 Nov 2019 16:30:33 -0300

ktap (0.4+git20160427-1ubuntu3) artful; urgency=medium

  * Linux 4.13 compatibility (LP: #1706427)
    - debian/patches/remove-strlen-user.patch

 -- Seth Forshee <seth.forshee@canonical.com>  Wed, 09 Aug 2017 08:12:13 -0500

ktap (0.4+git20160427-1ubuntu2) zesty; urgency=medium

  * linux v4.10 compatibility
    debian/patches/cycle-t.patch

 -- Tim Gardner <tim.gardner@canonical.com>  Thu, 16 Feb 2017 09:18:34 -0700

ktap (0.4+git20160427-1ubuntu1) zesty; urgency=medium

  * linux v4.9 compatibility
    debian/patches/gfp-nowait.patch
    debian/patches/perf-record-data.patch 

 -- Tim Gardner <tim.gardner@canonical.com>  Thu, 15 Dec 2016 11:07:32 -0700

ktap (0.4+git20160427-1) unstable; urgency=medium

  * Sync with upstream (Closes: #803241)

 -- Azat Khuzhin <a3at.mail@gmail.com>  Wed, 27 Apr 2016 18:49:03 +0300

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/ktap-$1.tar.gz/" \
    https://github.com/ktap/ktap/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
